SystemOrganization addCategory: #MiVillanoFavorito!

TestCase subclass: #TestsVillanoFavorito
	instanceVariableNames: 'unMinion unSuero arma1 arma2 arma3 villano'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!TestsVillanoFavorito methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 23:15'!
setUp
villano := Villano2 new.
unMinion := (villano nuevoMinion).
unMinion alimentar: 10.

arma1 := Arma2 new.
arma1 nombre: 'Rayo laser'.
arma1 potencia: 10.

arma2 := Arma2 new.
arma2 nombre: 'Rayo congelante'.
arma2 potencia: 15.

arma3 := Arma2 new.
arma3 nombre: 'Rayo encogedor'.
arma3 potencia: 12.! !

!TestsVillanoFavorito methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 23:22'!
testCantidadDeBananas

self assert: (unMinion cantidadDeBananas) equals: 15.
! !

!TestsVillanoFavorito methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 03:46'!
testMinionArmaMasPotente

unMinion otorgarArma: arma1.
unMinion otorgarArma: arma2.
unMinion otorgarArma: arma3.

self assert: (unMinion armaMasPotente) equals: arma2.! !

!TestsVillanoFavorito methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 03:23'!
testMinionCon15BananasTomaSueroMutante
unMinion tomarSuero.

self assert: (unMinion cantidadDeBananas) equals: 14.
self assert: (unMinion esPeligroso)! !

!TestsVillanoFavorito methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 03:24'!
testMinionCon15BananasTomaSueroMutanteDosVeces
unMinion tomarSuero.
unMinion tomarSuero.

self assert: (unMinion cantidadDeBananas) equals: 13.
self deny: (unMinion esPeligroso).! !

!TestsVillanoFavorito methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 03:44'!
testMinionConDosArmasTomaSueroMutante

unMinion otorgarArma: arma1.
unMinion otorgarArma: arma2.
unMinion tomarSuero.

self assert: (unMinion armas isEmpty)! !

!TestsVillanoFavorito methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 22:32'!
testMinionConTresArmas

unMinion otorgarArma: arma1.
unMinion otorgarArma: arma2.

self assert: (unMinion cantidadDeArmas) equals: 3.
self assert: (unMinion nivelDeConcentracion) equals: 30.! !

!TestsVillanoFavorito methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 23:26'!
testNivelConcentracionMinion
unMinion otorgarArma: arma1.
unMinion otorgarArma: arma2.
unMinion otorgarArma: arma3.

self assert: (unMinion nivelDeConcentracion) equals: 30.
! !

!TestsVillanoFavorito methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 23:22'!
testPotenciaDeMinionArmaMasPotente

unMinion otorgarArma: arma1.
unMinion otorgarArma: arma2.
unMinion otorgarArma: arma3.

self assert: ((unMinion armaMasPotente) potencia) equals: 15.! !

Object subclass: #Amarillo2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!Amarillo2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 03:24'!
esPeligroso: unMinion
^unMinion cantidadDeArmas > 2! !

!Amarillo2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 23:25'!
nivelDeConcentracion: unMinion
^(unMinion armaMasPotente) potencia + (unMinion cantidadDeBananas) ! !

!Amarillo2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 22:28'!
tomarSuero: unMinion
unMinion perderTodasLasArmas.
unMinion tipo: Violeta2 new.! !

Object subclass: #Arma2
	instanceVariableNames: 'nombre potencia'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!Arma2 class methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:37'!
crearArma: nombre dePotencia: potencia
|arma|
arma := Arma2 new.
arma nombre: nombre.
arma potencia: potencia.
^arma! !

!Arma2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 01:46'!
nombre
	^ nombre! !

!Arma2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 01:46'!
nombre: anObject
	nombre := anObject! !

!Arma2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 01:46'!
potencia
	^ potencia! !

!Arma2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 01:46'!
potencia: anObject
	potencia := anObject! !

Object subclass: #Ciudad2
	instanceVariableNames: 'temperatura objetos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!Ciudad2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 03:00'!
disminuirTemperatura: grados
self temperatura: (self temperatura - grados)! !

!Ciudad2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 02:59'!
objetos
	^ objetos! !

!Ciudad2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 02:59'!
objetos: anObject
	objetos := anObject! !

!Ciudad2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 02:59'!
temperatura
	^ temperatura! !

!Ciudad2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 02:59'!
temperatura: anObject
	temperatura := anObject! !

Object subclass: #Luna2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!Luna2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:59'!
afectarEn: ciudad
ciudad bajarTemperatura: 15.
self premiar.! !

!Luna2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:38'!
premiar
self minionsAsignados do: [ :minion | minion otorgarArma: (Arma2 crearArma: 'Rayo congelante' dePotencia: 10) ]! !

!Luna2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:31'!
verificarRequisitosPara: unMinion
^unMinion tiene: 'Rayo para encoger'! !

Object subclass: #Maldad2
	instanceVariableNames: 'minionsAsignados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

Maldad2 subclass: #Congelar2
	instanceVariableNames: 'nivelRequerido'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!Congelar2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 21:59'!
afectarEn: ciudad
ciudad bajarTemperatura: 30.
self premiar.
! !

!Congelar2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 01:34'!
initialize
self nivelRequerido: 500.! !

!Congelar2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 01:32'!
nivelRequerido
	^ nivelRequerido! !

!Congelar2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 01:32'!
nivelRequerido: anObject
	nivelRequerido := anObject! !

!Congelar2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:31'!
verificarRequisitosPara: unMinion
^(unMinion tiene: 'Rayo congelante') & (unMinion nivelDeConcentracion >= self nivelRequerido)! !

!Maldad2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 21:28'!
asignarMinions: minions
minionsAsignados := minions collect: [ :minion | self verificarRequisitosPara: minion ]! !

!Maldad2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 22:02'!
incrementarCantidadDeMisionesDeMinionsAsignados
self minionsAsignados do: [ :minion | minion incrementarCantidadDeMisiones ]! !

!Maldad2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 03:09'!
minionsAsignados
	^ minionsAsignados! !

!Maldad2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 03:09'!
minionsAsignados: anObject
	minionsAsignados := anObject! !

!Maldad2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 03:11'!
premiar
self minionsAsignados do: [ :minion | minion alimentar: 10 ]! !

!Maldad2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 22:02'!
realizarMaldadEn: unaCiudad
self incrementarCantidadDeMisionesDeMinionsAsignados.
self afectarEn: unaCiudad! !

Maldad2 subclass: #Robar2
	instanceVariableNames: 'objetoARobar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!Robar2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 22:04'!
afectarEn: ciudad
^objetoARobar afectarEn: ciudad! !

!Robar2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 20:23'!
objetoARobar
	^ objetoARobar! !

!Robar2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 20:23'!
objetoARobar: anObject
	objetoARobar := anObject! !

!Robar2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:28'!
verificarRequisitosPara: unMinion
^objetoARobar verificarRequisitosPara: unMinion! !

Object subclass: #Minion2
	instanceVariableNames: 'armas cantidadDeBananas tipo cantidadDeMisiones'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!Minion2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 02:11'!
alimentar: cantBananas
cantidadDeBananas := cantidadDeBananas + cantBananas! !

!Minion2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 23:15'!
armaMasPotente
^(self armas) detectMax: [ :arma | arma potencia ]! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 01:52'!
armas
	^ armas! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 02:06'!
armas: anObject
	armas := anObject! !

!Minion2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 02:13'!
cantidadDeArmas
^armas size! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 01:55'!
cantidadDeBananas
	^ cantidadDeBananas! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 01:56'!
cantidadDeBananas: cantidad
cantidadDeBananas := cantidad! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 00:19'!
cantidadDeMisiones
	^ cantidadDeMisiones! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 00:19'!
cantidadDeMisiones: anObject
	cantidadDeMisiones := anObject! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 03:24'!
esPeligroso
^(self tipo) esPeligroso: self! !

!Minion2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 03:01'!
estaBienAlimentado
^cantidadDeBananas >= 100! !

!Minion2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:51'!
incrementarCantidadDeMisiones
self cantidadDeMisiones: (self cantidadDeMisiones + 1)! !

!Minion2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:40'!
initialize
self tipo: (Amarillo2 new).
self cantidadDeBananas: 5.
self cantidadDeMisiones: 0.
self armas: (Set new).
self otorgarArma: (Arma2 crearArma: 'Rayo congelante' dePotencia: 10) ! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 03:28'!
nivelDeConcentracion
^(self tipo) nivelDeConcentracion: self! !

!Minion2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 02:10'!
otorgarArma: unArma
armas add: unArma! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 03:08'!
perderTodasLasArmas
self armas removeAll.! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 02:41'!
perderUnaBanana
self cantidadDeBananas: (self cantidadDeBananas - 1)! !

!Minion2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:30'!
tiene: unArma
^(self armas) anySatisfy: [ :arma | arma nombre = unArma ]! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 01:52'!
tipo
	^ tipo! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 01:52'!
tipo: anObject
	tipo := anObject! !

!Minion2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 22:28'!
tomarSuero
tipo tomarSuero: self.
self perderUnaBanana.! !

Object subclass: #Piramide2
	instanceVariableNames: 'altura'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!Piramide2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/25/2014 21:59'!
afectarEn: ciudad
self premiar.! !

!Piramide2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 02:34'!
altura
	^ altura! !

!Piramide2 methodsFor: 'accessing' stamp: 'JessSaavedra 10/24/2014 02:34'!
altura: anObject
	altura := anObject! !

!Piramide2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 01:39'!
initialize
self altura: 50! !

!Piramide2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:28'!
verificarRequisitosPara: unMinion
^(unMinion nivelDeConcentracion) >= (self altura / 2)! !

Object subclass: #SueroMutante2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!SueroMutante2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:59'!
afectarEn: ciudad
self premiar.! !

!SueroMutante2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 03:12'!
premiar
self minionsAsignados do: [ :minion | minion tomarSuero ]! !

!SueroMutante2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:28'!
verificarRequisitosPara: unMinion
^(unMinion estaBienAlimentado) & (unMinion nivelDeConcentracion >=23)! !

Object subclass: #Villano2
	instanceVariableNames: 'minions ciudad'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!Villano2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 20:24'!
agregarMaldad: maldad
self maldades add: maldad! !

!Villano2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 22:30'!
initialize 
minions := Set new.! !

!Villano2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 20:42'!
minionMasUtil
minions detectMax: [ :minion | minion cantidadDeMisiones ]! !

!Villano2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 22:05'!
minionsMasInutiles
minions collect: [ :minion | minion cantidadDeMisiones = 0 ]! !

!Villano2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 23:14'!
nuevoMinion
| minion |
minion := Minion2 new.
minions add: minion.
^minion! !

!Villano2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 21:25'!
planificar: maldad
maldad asignarMinions: (self minions).
self agregarMaldad: maldad.
! !

!Villano2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/25/2014 22:03'!
realizarMaldad: maldad
maldad realizarMaldadEn: (self ciudad)! !

Object subclass: #Violeta2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MiVillanoFavorito'!

!Violeta2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 03:24'!
esPeligroso: unMinion
^true! !

!Violeta2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 03:26'!
nivelDeConcentracion: unMinion
^unMinion cantidadDeBananas! !

!Violeta2 methodsFor: 'as yet unclassified' stamp: 'JessSaavedra 10/24/2014 22:28'!
tomarSuero: unMinion
unMinion tipo: Amarillo2 new.! !
